<template>
	<xn-form-container :title="'基本设置'" :width="800" :visible="visible" :destroy-on-close="true" @close="onClose">
		<a-form :model="formState" ref="formStateRef" :rules="formStateRules" name="basic" autocomplete="off">
			<div class="form">
				<a-row>
					<a-col :span="12">
						<a-form-item class="form-item" label="处室名称" name="departmentName" :label-col="{ span: 10 }">
							<a-input
								placeholder="请输入处室名称"
								style="width: 600px"
								:disabled="disabled"
								v-model:value="formState.departmentName"
							/>
						</a-form-item>
					</a-col>
				</a-row>
				<a-row>
					<a-col :span="12">
						<a-form-item class="form-item" label="机构类别" name="organizationCategory" :label-col="{ span: 10 }">
							<a-select :disabled="disabled" style="width: 220px" v-model:value="formState.organizationCategory">
								<a-select-option :value="1">内设机构</a-select-option>
								<a-select-option :value="2">直属单位</a-select-option>
							</a-select>
						</a-form-item>
					</a-col>
					<a-col :span="12">
						<a-form-item class="form-item" label="机构领导" name="leaderName" :label-col="{ span: 10 }">
							<a-input
								placeholder="请输入机构领导"
								style="width: 220px"
								:disabled="disabled"
								v-model:value="formState.leaderName"
							/>
						</a-form-item>
					</a-col>
				</a-row>
				<a-row>
					<a-col :span="12">
						<a-form-item class="form-item" label="职务" name="position" :label-col="{ span: 10 }">
							<a-input
								placeholder="请输入职务"
								style="width: 220px"
								:disabled="disabled"
								v-model:value="formState.position"
							/>
						</a-form-item>
					</a-col>
					<a-col :span="12">
						<a-form-item class="form-item" label="公室号码" name="officeNumber" :label-col="{ span: 10 }">
							<a-input
								placeholder="请输入公室号码"
								style="width: 220px"
								:disabled="disabled"
								v-model:value="formState.officeNumber"
							/>
						</a-form-item>
					</a-col>
				</a-row>
			</div>
			<div>职能简介:</div>
			<br />
			<!-- <div class="input">
				<a-textarea
					placeholder="请输入职能简介"
					v-model:value="formState.functionIntroduction"
					:disabled="disabled"
					allow-clear
				/>
			</div> -->
			<Editor
				:fileUploadFunction="global.uploadFile"
				:placeholder="'请输入职能简介'"
				:disabled="disabled"
				v-model:modelValue="formState.functionIntroduction"
			/>

			<a-form-item>
				<div class="item-submit">
					<a-button class="btn1" :disabled="disabled" @click="onFinish(2)">提交</a-button>
					<a-button class="btn1" :disabled="disabled" type="primary" @click="onFinish(1)">保存</a-button>
				</div>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
		</template>
	</xn-form-container>
</template>
<script lang="js">
	import business from '@/api/home/home.js'
	import { ref } from 'vue'
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import global from '@/api/home/global.js'
	export default {
		name: 'FromName',
		components: {},
		emits: ['change'],
		setup(props, { emit }) {
			const disabled = ref(false)
			const visible = ref(false)
			const records = ref('')
			const onOpen = (record, flag, view, row) => {
				records.value = record
				visible.value = flag
				disabled.value = view
				if (row) {
					detail(row.id)
				}
			}
			const rest = () => {
				for (let key in formState.value) {
					formState.value[key] = ''
				}
			}
			const detail = async (v) => {
				const res = await business.ZNXXdetail({ id: v })
				formState.value = res
			}
			const onClose = () => {
				rest()
				visible.value = false
			}
			watch(
				() => visible.value,
				(newVal) => {
					if (!newVal) {
						setTimeout(() => {
							rest()
						}, 0)
					}
				},
				{ immediate: true, deep: true }
			)

			const formState = ref({
				departmentName: '',
				organizationCategory: '',
				leaderName: '',
				position: '',
				officeNumber: '',
				functionIntroduction: '',
				status: 0
			})
			const formStateRules = ref({
				systemName: [{ required: true, message: '请填写!', trigger: 'blur' }],
				publishTime: [{ required: true, message: '请填写!', trigger: 'change' }],
				attachment: [{ required: true, message: '请填写!', trigger: 'change' }]
			})
			const formStateRef = ref(null)
			const onFinish = async (status) => {
				formStateRef.value.validate().then(async () => {
					try {
						formState.value.status = status
						await handleAdd(formState.value)
						emit('change')
						onClose()
					} catch (err) {
						console.log(err)
					}
				})
			}

			const handleAdd = async (val) => {
				if (records.value == 'edit') {
					const res = await business.ZNXXedit(val)
				} else {
					const res = await business.ZNXXadd(val)
					console.log('add')
				}
			}

			const delADD = () => {
				formStateRef.value.validate().then(() => {})
			}

			const onFinishFailed = (errorInfo) => {
				console.log('Failed:', errorInfo)
			}
			function changeUpload(fd) {
				return global.uploadFile(fd).then((reg) => {
					uploadDataList.value.clearValidate()
					return reg
				})
			}
			const uploadDataList = ref(null)
			function beforeUpload() {
				uploadDataList.value.clearValidate()
			}

			return {
				global,
				beforeUpload,
				uploadDataList,
				changeUpload,
				delADD,
				formStateRef,
				formStateRules,
				formState,
				onFinish,
				onFinishFailed,
				disabled,
				onOpen,
				visible,
				onClose
			}
		}
	}
</script>
<style lang="less" scoped>
	.box1 {
		display: flex;
		justify-content: space-between;
		.box-left {
			width: 350px;
			align-items: center;
		}
		.box-right {
			width: 350px;
			margin-right: 10px;
			align-items: center;
		}
	}
	.common {
		display: flex;
		align-items: center;
		justify-content: center;
		margin-bottom: 30px;
		.title {
			width: 130px;
			text-align: right;
			margin-right: 5px;
		}
	}
	.input {
		margin-right: 10px;
		margin-left: 40px;
		margin-top: 20px;
		.ant-input-affix-wrapper {
			height: 100px;
		}
	}
	.btnBox {
		text-align: center;
		margin-top: 100px;
		.snowy-buttom-left {
			margin-left: 100px;
		}
		.acc {
			width: 80px;
			height: 40px;
		}
	}
	.form {
		display: flex;
		flex-wrap: wrap;
		// justify-content: center;
		.form-item {
			width: 250px;
			margin-right: 120px;
		}
	}
	.item-submit {
		display: flex;
		justify-content: center;
		margin-top: 100px;
		.btn1 {
			width: 100px;
			margin-right: 20px;
		}
	}
	.ant-select {
		width: 250px;
	}
	.ant-input {
		width: 250px;
	}
	.ant-form-item-label {
		width: 150px;
	}
	.attachment {
		margin-top: 30px;
		margin-left: 15px;
	}
</style>
